#!/bin/bash
set -e
# create sparse test file
rm -f test test.lzo.enc test.lzo.enc2 test.cmp
./dd_rescue -t -S 256k dd_rescue test
./dd_rescue -t -S 2048k dd_rescue test
./dd_rescue -x -m 256k /dev/zero test
# Chain with hash, compress, hash, encrypt, hash
SIZE=$(stat -Lc "%s" test)
echo ./dd_rescue -L ./libddr_hash.so=sha256,./libddr_lzo.so=compress,./libddr_hash.so=sha256,./libddr_crypt.so=aes192-ctr:pbkdf2:pass=PASS:enc,./libddr_hash.so=sha256 test test.lzo.enc
./dd_rescue -L ./libddr_hash.so=sha256,./libddr_lzo.so=compress,./libddr_hash.so=sha256,./libddr_crypt.so=aes192-ctr:pbkdf2:pass=PASS:enc,./libddr_hash.so=sha256 test test.lzo.enc
echo ./dd_rescue -L ./libddr_hash.so=sha256,./libddr_crypt.so=aes192-ctr:pbkdf2:pass=PASS:dec:saltlen=$SIZE,./libddr_hash.so=sha256,./libddr_lzo.so=decompress,./libddr_hash.so=sha256 test.lzo.enc test.cmp
./dd_rescue -L ./libddr_hash.so=sha256,./libddr_crypt.so=aes192-ctr:pbkdf2:pass=PASS:dec:saltlen=$SIZE,./libddr_hash.so=sha256,./libddr_lzo.so=decompress,./libddr_hash.so=sha256 test.lzo.enc test.cmp
echo cmp test test.cmp
cmp test test.cmp
echo ./dd_rescue -aL ./libddr_hash.so=sha256,./libddr_lzo.so=compress,./libddr_hash.so=sha256,./libddr_crypt.so=aes192-ctr:pbkdf2:pass=PASS:enc,./libddr_hash.so=sha256 test test.lzo.enc2
./dd_rescue -aL ./libddr_hash.so=sha256,./libddr_lzo.so=compress,./libddr_hash.so=sha256,./libddr_crypt.so=aes192-ctr:pbkdf2:pass=PASS:enc,./libddr_hash.so=sha256 test test.lzo.enc2
echo ./dd_rescue -taL ./libddr_hash.so=sha256,./libddr_crypt.so=aes192-ctr:pbkdf2:pass=PASS:dec:saltlen=$SIZE,./libddr_hash.so=sha256,./libddr_lzo.so=decompress,./libddr_hash.so=sha256 test.lzo.enc2 test.cmp
./dd_rescue -taL ./libddr_hash.so=sha256,./libddr_crypt.so=aes192-ctr:pbkdf2:pass=PASS:dec:saltlen=$SIZE,./libddr_hash.so=sha256,./libddr_lzo.so=decompress,./libddr_hash.so=sha256 test.lzo.enc2 test.cmp
echo cmp test test.cmp
cmp test test.cmp
rm -f test test.lzo.enc test.lzo.enc2 test.cmp
